;### SSL/TLS δ
require './jcode.pl';
require './config.cgi';
($CERT,$CHAIN,$KEY,$CSR) = ('server.cert','intermediate.cert','server.key','server.csr');
$sslroot = "$cfg{mailroot}/sslconf";		# XMailCFG񥹥ȥ
&error(2,$sslroot) if !-d $sslroot;
$arrowB = "<img src='$idir/arrow3.gif' width=32 height=13 border=0 alt=''>";
$caroot = "$sslroot/CA";					# Ūǧڶɥ롼
$conf = 'openssl.conf';						# OpenSSLե̾
$days2 = 10000;								# Ūǧڶͭ
$debug = 0;									# 1ǥǥХå⡼
$debugfile = '../temp/ssl_report.txt';		# 顼ϥե(../temp)
$der = 'ca.der';							# ŪǧڶɥХʥ(饤Ȥ˥󥹥ȡ)
$myindex = '../temp/mycerts.txt';			# ŪǧڶɤˤΥǥå
$openssl = "$cfg{xmaildir}/openssl";		# OpenSSLޥ
$openssl =~ s/\//\\/g if !$OS;
$sha = 'sha256';							# ̾르ꥺ
$top = "<div align='right'><a href='#top'><u> </u></a></div>";
$ENV{'OPENSSL_CONF'} = '';					# ưɻߤΤ
$ENV{'RANDFILE'} = '../temp/.rnd';			# .rndե

## ̩Ȥڥå
sub chk_pair {
	my ($data1,$file1,$data2,$file2) = @_;		# 1:̩(server.key)2:(server.cert)
	my ($tmp1,$tmp2) = ('../temp/tempKey.txt','../temp/tempCert.txt');		# ǡ¸
	my $OK;
	
	if ($data1 && open(FILE,">$tmp1")){
			print FILE $data1;
		close(FILE);
		$file1 = $tmp1;
	}
	if ($data2 && open(FILE,">$tmp2")){
			print FILE $data2;
		close(FILE);
		$file2 = $tmp2;
	}
	&html("̩ȥоꤹɬפޤ") if (!-s $file1 || !-s $file2);
	
	my ($str1,$str2,$str3);
	$str1 = `$openssl rsa -in $file1 -pubout 2>&1`;			# ̩
	$str2 = `$openssl x509 -in $file2 -pubkey 2>&1`;		# 
	$str1 =~ s/writing.+//;
	$str1 =~ s/[\n\r]//g;
	($str2) = &remove_garb($str2);
	foreach (split(/[\n\r]+/,$str2)){
		last if /^-+BEGIN CERTIFICATE-+/;
		$str3 .= $_;
	}
	# ޤϰʲǤOK
	#$str1 = `$openssl rsa -noout -modulus -in $file1|$openssl md5`;
	#$str2 = `$openssl x509 -noout -modulus -in $fil2|$openssl md5`;
	#return(1) if $str1 eq $str2;
	
	$OK = 1 if $str1 eq $str3;		# 
	$OK;
}

## ѴĶå
sub chk_ssl_env {
	# XMail/XMailCFGĶ
	# openssl.exe, libeay32.dll, ssleay32.dll
	# CA񡢥о̩DER
	%xmail = &get_env("$cfg{mailroot}/server.tab");
	$sslver = `$openssl version`;
	if ($sslver =~ /^OpenSSL (\d.+?) /i){$sslver = $1;} else {$sslver = '';}
	if (!$OS){
		#$libeay = 1 if -f "$ENV{'SystemRoot'}\\system32\\libeay32.dll";
		#$ssleay = 1 if -f "$ENV{'SystemRoot'}\\system32\\ssleay32.dll";
		$libeay = 1 if -f "$cfg{xmaildir}/libeay32.dll";
		$ssleay = 1 if -f "$cfg{xmaildir}/ssleay32.dll";
	}
	$cacert = 1 if -f "$cfg{mailroot}/certs.pem";
	$cacert = 1 if (!$cacert && glob("$cfg{mailroot}/certs\\*.0"));
	$cacert2 = 1 if $xmail{SSLWantCert};
	$servercert = 1 if -f "$cfg{mailroot}/$CERT";
	$serverkey = 1 if -f "$cfg{mailroot}/$KEY";
}

## ǥХå
sub debug_ssl {
	my ($str1,$str2,$str3) = @_;
	
	open(FILE,">>$debugfile");
		print FILE " $str1 - $str2 ($year/$month/$mday $hour:$min)\n";
		print FILE "----------------------------------------------------------------\n";
		print FILE "$str3\n\n";
	close(FILE);
}

## **ǯ
sub get_date2 {
	my ($count) = @_;
	
	my $time = time() + 60 * 60 * 24 * $count;
	my @tmp = localtime($time);
	my ($year,$month,$day) = ($tmp[5],$tmp[4],$tmp[3]);
	$year += 1900;
	$month++;
	$month1 = sprintf("%02d",$month);
	$day1 = sprintf("%02d",$day);
	
	"$year/$month1/$day1";
}

## ɤ
sub get_template {
	my ($op1,$op2) = @_;	# op1(0:Server, 1:Client)
	my (@dirlist,@tmp);		# op2(0:Public, 1:SelfSigned, 2:SelfSignedByPrivateCA
	$op1 = 0 if $op1 eq '';
	$op2 = 0 if $op2 eq '';
	
	opendir(DIR,$sslroot);
		@dirlist = readdir(DIR);
	closedir(DIR);
	foreach my $dir (@dirlist){
		my $tab = "$sslroot/$dir/profile.tab";
		next if (!-s $tab || $dir !~ /\d{8}-\d{6}/);
		my %e = &get_env($tab,'=');
		my ($e1,$e2) = ($e{IDType},$e{CertType});
		$e1 = 0 if $e1 eq '';
		$e2 = 0 if $e2 eq '';
		next if $op1 ne "$e1";
		next if $op2 ne "$e2";
		push(@tmp,"$dir\t$e{Created}\t$e{CommonName}");
	}
	reverse(@tmp);
}

## ȥID
sub make_mystore {
	$storeid = "$year$month$mday-$hour$min$sec";
	$mystore = "$sslroot/$storeid";
	mkdir($mystore,0755);
	&error('100','񥹥ȥǤޤǤ',"$sslroot ΥǧƤ") if !-d $mystore;
}

## ̩ե$sslroot/$storeid˺
sub make_privatekey {
	my ($length,$storeid) = @_;		# $length:Ĺ
	$mystore = "$sslroot/$storeid";
	return(1) if -s "$mystore/$KEY";
	
	my $str = time();
	my $mypass = md5_hex $str;
	mkdir($mystore,0755);
	my $tmp = `$openssl genrsa -des3 -out $mystore/$KEY -passout pass:$mypass -rand $ENV{SystemRoot} $keylength 2>&1`;
	$tmp = `$openssl rsa -passin pass:$mypass -in $mystore/$KEY -out $mystore/$KEY 2>&1`;		# ѥե졼
	return(1) if -s "$mystore/$KEY";
}

## եå3ɽ
sub print_footer2 {
	print "</blockquote>\n";
	&print_footer();
	exit;
}

## إå2ɽ
sub print_header2 {
	my ($subtitle,$error) = @_;
	&print_header($subtitle,'','','600','600');
	print "<blockquote>\n";
	print "<p>$fs4R$alert $error$fe</p>\n" if $error;
}

## ĶԽʬSSL/TLSåȥå׼¹ǽ
sub print_invalid_env {
	print <<"EOF";
$fs2
<p>åȥå״ĶԽʬǤ<br>
顼å򻲹ͤɬפʺȤԤθܥ˥塼Ƽ¹ԤƤ</p>
$fe
EOF
	&print_footer2();
}

## WindowsĶؤηٹ
sub print_os_notice {
	print "<p>$fs2 Windows Ķξ硢ܥ˥塼ưʤǽޤ<br>\n";
	print "Windows Ķ $xmailcfg Ǻ Windows ĶǤ⤽ΤޤѤǤޤ$fe</p>\n";
}

## ߺ
sub remove_garb {
	my @tmp = @_;
	my @tmp1;
	
	foreach (@tmp){
		s/^Loading .+?state *//;
		s/</&lt;/g;
		s/>/&gt;/g;
		s/(-+[\n\r]+).+[\n\r]*$/$1/;
		push(@tmp1,$_);
	}
	
	@tmp1;
}

## openssl.conf
sub save_openssl_conf {
	my ($type,$op) = @_;
	my ($dir1,$str0,$str1,$str2,$str3,$str4,$str5,$str6,$str7);
	my ($conf1,$dir) = ($conf,$caroot);
	
	if ($type eq 'CA'){
		$dir1 = $caroot;
		$str0 = 'unique_subject = yes';
		$str1 = 'match';
		$str2 = $mypass;
		$str3 = 'x509_extensions = v3_ca';
		$str4 = 'req_extensions = v3_req';
		$str5 = 'nsCertType = server';
		$str6 = 'nsCertType = sslCA,emailCA';
	} elsif ($type eq 'server'){
		$dir1 = $mystore;
		$str1 = 'optional';
		$str2 = $mypass;
		$str3 = 'x509_extensions = v3_ca';
		$str4 = 'req_extensions = v3_req';
		$str5 = 'nsCertType = server';
#		$str6 = 'nsCertType = sslCA,emailCA';
		$str7 = "subjectAltName = email:copy, DNS:$AltName" if $AltName;
	} elsif ($type eq 'client'){
		$dir1 = $mystore;
		$str1 = 'optional';
		$str2 = $i{mypass};
#		$str3 = 'x509_extensions = v3_ca';
#		$str4 = 'req_extensions = v3_req';
		$str5 = 'nsCertType = client,email';
#		$str6 = 'nsCertType = sslCA,emailCA';
	} elsif ($type eq 'revoke'){
		$conf1 = $op;
		$dir1 = $caroot;
		$str2 = $i{mypass};
	} else {				# csr
		$conf1 = $op if $op;
		$dir1 = $mystore;
		$str2 = $mypass;
	}
	$dir =~ s/\\/\//g;
	$dir1 =~ s/\\/\//g;
	
	open(FILE,">$dir1/$conf1");
	if ($type ne 'CSR'){
		print FILE <<"EOF";
[ ca ]
default_ca = CA_default

[ CA_default ]
dir = $dir
certs = \$dir/certs
crl_dir = \$dir/crl
database = \$dir/index.txt
$str0
new_certs_dir = \$dir/newcerts
certificate = \$dir/cacert.pem
serial = \$dir/serial
crlnumber = \$dir/crlnumber
crl = \$dir/crl.pem
private_key = \$dir/private/cakey.pem
randfile = \$dir/private/.rand
x509_extensions = usr_cert
name_opt = ca_default
cert_opt = ca_default
default_days = 1095
default_crl_days = 30
default_md = $sha
preserve = no
policy = policy_match

[ policy_match ]
countryName = $str1
stateOrProvinceName = $str1
organizationName = $str1
organizationalUnitName = optional
commonName = supplied
emailAddress = optional

EOF
	}
	
	print FILE <<"EOF";
[ req ]
default_bits = 1024
default_keyfile = privkey.pem
distinguished_name = req_distinguished_name
$str3
input_password = $str2
output_password = $str2
string_mask = nombstr
$str4

[ req_distinguished_name ]
countryName = Country Name (2 letter code)
countryName_value = $Country
stateOrProvinceName = State or Province Name (full name)
stateOrProvinceName_value = $Province
localityName = Locality Name (eg, city)
localityName_value = $Locality
0.organizationName = Organization Name (eg, company)
0.organizationName_value = $Organization
organizationalUnitName = Organizational Unit Name (eg, section)
organizationalUnitName_value = $Unit
commonName = Common Name (eg, YOUR name)
commonName_value = $CommonName
emailAddress = Email Address
emailAddress_value = $Email

[ usr_cert ]
basicConstraints = CA:FALSE
$str5
nsComment = "OpenSSL Generated Certificate"
subjectKeyIdentifier = hash
authorityKeyIdentifier = keyid,issuer:always
#authorityKeyIdentifier = keyid,issuer

[ v3_req ]
basicConstraints = CA:FALSE
keyUsage = nonRepudiation,digitalSignature,keyEncipherment
$str7

[ v3_ca ]
subjectKeyIdentifier = hash
authorityKeyIdentifier = keyid:always,issuer:always
basicConstraints = CA:true
$str6

[ crl_ext ]
authorityKeyIdentifier = keyid:always,issuer:always
EOF
	close(FILE);
}
1;
